#### The following variables are set by "make check". Ensure
#### that they are set here so that individual tests can be run
#### outside of make. Requires that MH_OBJ_DIR be set on entry.
-test -z "$MH_TEST_DIR" && MH_TEST_DIR="$MH_OBJ_DIR/test/testdir"
+#### Use the result of cd and pwd -P so that the result will agree
+#### with what getcwd(3) returns.
+test -d "$MH_OBJ_DIR/test/testdir" || mkdir -p "$MH_OBJ_DIR/test/testdir"
+test -z "$MH_TEST_DIR" && MH_TEST_DIR=`cd "$MH_OBJ_DIR/test/testdir" && pwd -P`
+export MH_TEST_DIR
test -z "$MH_INST_DIR" && MH_INST_DIR="${MH_TEST_DIR}/inst"
test -z "$MH_VERSION" && MH_VERSION="@VERSION@"
test -z "$prefix" && prefix=@prefix@
test -z "$OAUTH_SUPPORT" && OAUTH_SUPPORT="@OAUTH_SUPPORT@"
test -z "$CURL_USER_AGENT" && CURL_USER_AGENT="@CURL_USER_AGENT@"
+#### If w3m is used, HOME needs to be set, assuming default w3m config.
+#### So make sure that HOME is set to avoid run-time warning about not
+#### being able to create config directory.
+test -z "$HOME" && HOME=$MH_TEST_DIR
+HOME=$MH_TEST_DIR
+export HOME
+
+#### If w3m is used, HOME needs to be set, assuming default w3m config.
+#### So make sure that HOME is set to avoid run-time warning about not
+#### being able to create config directory.
+test -z "$HOME" && HOME=$MH_TEST_DIR
+HOME=$MH_TEST_DIR
+export HOME
+
unset MAILDROP MHBUILD MHCONTEXT MHMTSUSERCONF MHN MHSHOW MHSTORE
-unset MHLDEBUG MHPDEBUG MHWDEBUG PAGER
+unset MHLDEBUG MHPDEBUG MHWDEBUG PAGER XOAUTH SMTPUTF8
#### Set LC_ALL in individual tests as needed. Unset these so
#### that we don't depend on user's settings in other tests.
unset LANG LC_ALL LC_CTYPE
}
# Skip test if none of the offered locales are supported.
+# As side effect, use the first locale that is found. Note that
+# some platforms allow, by way of example, en_US.UTF-8 to be used
+# even though en_US.UTF8 is listed by locale -a. But by setting
+# LC_ALL here, we don't rely on that.
require_locale ()
{
for locale in "$@"; do
if locale -a | grep -i "$locale" >/dev/null; then
+ LC_ALL="$locale"; export LC_ALL
return
fi
done
set +e
printf '' > "${MH_TEST_DIR}/$$-1"
+ xdir_links_supported=0
if link "${MH_TEST_DIR}/$$-1" "${MH_TEST_DIR}/$$-2" 2>/dev/null; then
hard_links_supported=1
+ mkdir "${MH_TEST_DIR}/xlinkdir"
+ if link "${MH_TEST_DIR}/$$-1" "${MH_TEST_DIR}/xlinkdir/$$-2" 2>/dev/null; then
+ xdir_links_supported=1
+ fi
else
hard_links_supported=0
fi
rm -f "${MH_TEST_DIR}/$$-1" "${MH_TEST_DIR}/$$-2"
+ rm -rf "${MH_TEST_DIR}/xlinkdir"
set -e
}
#### Optional arguments:
#### 'keep first' -- first file is removed unless this is present.
#### 'ignore space' -- spacing differences will not be considered
-#### signficant, emulating GNU diff -w. It is assumed that the
+#### significant, emulating GNU diff -w. It is assumed that the
#### first file has already been run through prepare_space.
#### ':' <test name> -- will print '<test name>' in the failure message,
#### to make it easier to tell which of multiple tests has failed.
#### Function to set the test name, and whatever the future brings.
start_test() {
- nmh_tests_testname="$1"
+ #### run_test disables exit on non-zero status, but does increment
+ #### failed. Don't overwrite nmh_tests_testname if there was a
+ #### failure; remember the first test that failed.
+ [ ${failed:-0} -eq 0 ] && nmh_tests_testname="$1"
}
#### Corresponding function to indicate that the test has finished. It need
#### not be called after each test, just the last one in a file.
finish_test() {
- unset nmh_tests_testname
+ #### run_test disables exit on non-zero status, but does increment
+ #### failed. Don't unset nmh_tests_testname if there was a failure.
+ [ ${failed:-0} -eq 0 ] && unset nmh_tests_testname
}
setup_test ()
# clean old test data on exit
trap cleanup 0
+
# setup test data
mkdir -p "$MH_TEST_DIR/Mail" || exit 1
cat > "$MH" <<EOF || exit 1
fi
folder -create +inbox > /dev/null
+ #### Suppress warnings about a new version.
+ #### mhparam version includes the nmh- prefix, so be consistent with that.
+ printf 'Version: nmh-%s\n' "${MH_VERSION}" >> "${MH_TEST_DIR}"/Mail/context
+
# create 10 basic messages
for i in 1 2 3 4 5 6 7 8 9 10;
do